Index: vsftpd-3.0.3/features.c
===================================================================
--- vsftpd-3.0.3.orig/features.c
+++ vsftpd-3.0.3/features.c
@@ -22,7 +22,7 @@ handle_feat(struct vsf_session* p_sess)
     {
       vsf_cmdio_write_raw(p_sess, " AUTH SSL\r\n");
     }
-    if (tunable_tlsv1 || tunable_tlsv1_1 || tunable_tlsv1_2)
+    if (tunable_tlsv1 || tunable_tlsv1_1 || tunable_tlsv1_2 || tunable_tlsv1_3)
     {
       vsf_cmdio_write_raw(p_sess, " AUTH TLS\r\n");
     }
Index: vsftpd-3.0.3/parseconf.c
===================================================================
--- vsftpd-3.0.3.orig/parseconf.c
+++ vsftpd-3.0.3/parseconf.c
@@ -87,6 +87,7 @@ parseconf_bool_array[] =
   { "ssl_tlsv1", &tunable_tlsv1 },
   { "ssl_tlsv1_1", &tunable_tlsv1_1 },
   { "ssl_tlsv1_2", &tunable_tlsv1_2 },
+  { "ssl_tlsv1_3", &tunable_tlsv1_3 },
   { "tilde_user_enable", &tunable_tilde_user_enable },
   { "force_anon_logins_ssl", &tunable_force_anon_logins_ssl },
   { "force_anon_data_ssl", &tunable_force_anon_data_ssl },
Index: vsftpd-3.0.3/ssl.c
===================================================================
--- vsftpd-3.0.3.orig/ssl.c
+++ vsftpd-3.0.3/ssl.c
@@ -86,6 +86,10 @@ ssl_init(struct vsf_session* p_sess)
     {
       options |= SSL_OP_NO_TLSv1_2;
     }
+    if (!tunable_tlsv1_3)
+    {
+      options |= SSL_OP_NO_TLSv1_3;
+    }
     SSL_CTX_set_options(p_ctx, options);
     if (tunable_rsa_cert_file)
     {
Index: vsftpd-3.0.3/tunables.c
===================================================================
--- vsftpd-3.0.3.orig/tunables.c
+++ vsftpd-3.0.3/tunables.c
@@ -68,6 +68,7 @@ int tunable_sslv3;
 int tunable_tlsv1;
 int tunable_tlsv1_1;
 int tunable_tlsv1_2;
+int tunable_tlsv1_3;
 int tunable_tilde_user_enable;
 int tunable_force_anon_logins_ssl;
 int tunable_force_anon_data_ssl;
@@ -209,10 +210,11 @@ tunables_load_defaults()
   tunable_force_local_data_ssl = 1;
   tunable_sslv2 = 0;
   tunable_sslv3 = 0;
-  /* TLSv1 up to TLSv1.2 is enabled by default */
+  /* TLSv1 up to TLSv1.3 is enabled by default */
   tunable_tlsv1 = 1;
   tunable_tlsv1_1 = 1;
   tunable_tlsv1_2 = 1;
+  tunable_tlsv1_3 = 1;
   tunable_tilde_user_enable = 0;
   tunable_force_anon_logins_ssl = 0;
   tunable_force_anon_data_ssl = 0;
Index: vsftpd-3.0.3/tunables.h
===================================================================
--- vsftpd-3.0.3.orig/tunables.h
+++ vsftpd-3.0.3/tunables.h
@@ -69,6 +69,7 @@ extern int tunable_sslv3;
 extern int tunable_tlsv1;                     /* Allow TLSv1 */
 extern int tunable_tlsv1_1;                   /* Allow TLSv1.1 */
 extern int tunable_tlsv1_2;                   /* Allow TLSv1.2 */
+extern int tunable_tlsv1_3;                   /* Allow TLSv1.3 */
 extern int tunable_tilde_user_enable;         /* Support e.g. ~chris */
 extern int tunable_force_anon_logins_ssl;     /* Require anon logins use SSL */
 extern int tunable_force_anon_data_ssl;       /* Require anon data uses SSL */
Index: vsftpd-3.0.3/vsftpd.conf.5
===================================================================
--- vsftpd-3.0.3.orig/vsftpd.conf.5
+++ vsftpd-3.0.3/vsftpd.conf.5
@@ -486,7 +486,7 @@ Default: YES
 Only applies if
 .BR ssl_enable
 is activated. If enabled, this option will permit SSL v2 protocol connections.
-TLS v1.2 connections are preferred.
+TLS v1.2+ connections are preferred.
 
 Default: NO
 .TP
@@ -494,7 +494,7 @@ Default: NO
 Only applies if
 .BR ssl_enable
 is activated. If enabled, this option will permit SSL v3 protocol connections.
-TLS v1.2 connections are preferred.
+TLS v1.2+ connections are preferred.
 
 Default: NO
 .TP
@@ -502,7 +502,7 @@ Default: NO
 Only applies if
 .BR ssl_enable
 is activated. If enabled, this option will permit TLS v1 protocol connections.
-TLS v1.2 connections are preferred.
+TLS v1.2+ connections are preferred.
 
 Default: YES
 .TP
@@ -510,7 +510,7 @@ Default: YES
 Only applies if
 .BR ssl_enable
 is activated. If enabled, this option will permit TLS v1.1 protocol connections.
-TLS v1.2 connections are preferred.
+TLS v1.2+ connections are preferred.
 
 Default: YES
 .TP
@@ -518,7 +518,15 @@ Default: YES
 Only applies if
 .BR ssl_enable
 is activated. If enabled, this option will permit TLS v1.2 protocol connections.
-TLS v1.2 connections are preferred.
+TLS v1.2+ connections are preferred.
+
+Default: YES
+.TP
+.B ssl_tlsv1_3
+Only applies if
+.BR ssl_enable
+is activated. If enabled, this option will permit TLS v1.3 protocol connections.
+TLS v1.2+ connections are preferred.
 
 Default: YES
 .TP
